# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2004-TODAY
#        Norprevención, S.L. (http://www.norprevencion.com) All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from osv import fields, osv
from tools.translate import _
import time


class hr_holiday_calendar_event(osv.osv):

    _name = "hr.holiday.calendar.event"
    _description = "Holiday event"
    _inherit = 'calendar.event'


    _columns = {
        'name': fields.char('Description', size=256, required=True),
        'scope': fields.selection([('autonomico', 'Autonomic'),('nacional', 'National')], 'Scope'),
        'country_id' :  fields.many2one('res.country', 'Country'),
        #'state_id': fields.many2one('res.country.region', 'State', domain="[('country_id','=',country_id)]"),
        'state_ids': fields.many2many('res.country.region', 'hr_holiday_state_rel', 'holiday_id', 'state_id', 'States where this holiday apply',domain="[('country_id','=',country_id)]"),
        'company_id': fields.many2one('res.company', 'Company'),
    }

    _defaults = {
        'scope': 'nacional',
    }


hr_holiday_calendar_event()