# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2004-TODAY
#        Norprevención, S.L. (http://www.norprevencion.com) All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
import datetime
import decimal_precision as dp

class hr_holidays_employee (osv.osv):
    """
        Auxiliar class for linking holidays to employees...
    """

    def _get_employee_sickness(self, cr, uid, ids, name, args, context=None):
        """

        """
        #Obtenemos todas las peticiones de ausencia validadas de un tipo determinado
        data_facade = self.pool.get('ir.model.data')
        holidays_facade = self.pool.get('hr.holidays')
        result = {}
        action_model,sickness_status_id = data_facade.get_object_reference(cr, uid, 'hr_holidays_extended', "hr_holidays_status_sickness")
        for hol in self.browse(cr, uid, ids, context=context):
            taken_days = 0.0
            first_day_of_year = '%s-01-01'%(hol.year)
            last_day_of_year = '%s-12-31' %(hol.year)
            requests_accepted = holidays_facade.browse(cr, uid, holidays_facade.search(cr, uid, [('employee_id','=', hol.employee_id.id),('type','=','remove'),('state','=', 'validate'), ('holiday_status_id','=', sickness_status_id), ('date_from','>=', first_day_of_year), ('date_from','<=',last_day_of_year), ('date_to','>=', first_day_of_year), ('date_to','<=',last_day_of_year)]))
            for request in requests_accepted:
                taken_days += request.number_of_days_temp

            result[hol.id] = taken_days

        return result


    def _get_taken_own_business(self, cr, uid, ids, name, args, context=None):
        """

        """
        #Obtenemos todas las peticiones de ausencia validadas de un tipo determinado
        data_facade = self.pool.get('ir.model.data')
        holidays_facade = self.pool.get('hr.holidays')
        result = {}
        action_model,own_business_status_id = data_facade.get_object_reference(cr, uid, 'hr_holidays_extended', "hr_holidays_status_own_business")
        for hol in self.browse(cr, uid, ids, context=context):
            taken_days = 0.0
            first_day_of_year = '%s-01-01'%(hol.year)
            last_day_of_year = '%s-12-31' %(hol.year)
            requests_accepted = holidays_facade.browse(cr, uid, holidays_facade.search(cr, uid, [('employee_id','=', hol.employee_id.id),('type','=','remove'),('state','=', 'validate'), ('holiday_status_id','=', own_business_status_id), ('date_from','>=', first_day_of_year), ('date_from','<=',last_day_of_year), ('date_to','>=', first_day_of_year), ('date_to','<=',last_day_of_year)]))
            for request in requests_accepted:
                taken_days += request.number_of_days_temp

            result[hol.id] = taken_days

        return result

    def _get_taken_holidays(self, cr, uid, ids, name, args, context=None):
        """

        """
        #Obtenemos todas las peticiones de ausencia validadas de un tipo determinado
        data_facade = self.pool.get('ir.model.data')
        holidays_facade = self.pool.get('hr.holidays')
        result = {}
        action_model,holidays_status_id = data_facade.get_object_reference(cr, uid, 'hr_holidays_extended', "hr_holidays_status_holiday")
        for hol in self.browse(cr, uid, ids, context=context):
            taken_days = 0.0
            first_day_of_year = '%s-01-01'%(hol.year)
            last_day_of_year = '%s-12-31' %(hol.year)
            requests_accepted = holidays_facade.browse(cr, uid, holidays_facade.search(cr, uid, [('employee_id','=', hol.employee_id.id),('type','=','remove'),('state','=', 'validate'), ('holiday_status_id','=', holidays_status_id), ('date_from','>=', first_day_of_year), ('date_from','<=',last_day_of_year), ('date_to','>=', first_day_of_year), ('date_to','<=',last_day_of_year)]))
            for request in requests_accepted:
                taken_days += request.number_of_days_temp

            result[hol.id] = taken_days
            
        return result

    def _get_available_own_business(self, cr, uid, ids, name, args, context=None):
        """

        """
        #Obtenemos todas las peticiones de ausencia validadas de un tipo determinado
        result = {}
        data_facade = self.pool.get('ir.model.data')
        holidays_facade = self.pool.get('hr.holidays')
        action_model,own_business_status_id = data_facade.get_object_reference(cr, uid, 'hr_holidays_extended', "hr_holidays_status_own_business")
        for hol in self.browse(cr, uid, ids, context=context):
            taken_days = 0.0
            first_day_of_year = '%s-01-01'%(hol.year)
            last_day_of_year = '%s-12-31' %(hol.year)
            requests_accepted = holidays_facade.browse(cr, uid, holidays_facade.search(cr, uid, [('employee_id','=', hol.employee_id.id),('type','=','remove'),('state','=', 'validate'), ('holiday_status_id','=', own_business_status_id), ('date_from','>=', first_day_of_year), ('date_from','<=',last_day_of_year), ('date_to','>=', first_day_of_year), ('date_to','<=',last_day_of_year)]))
            for request in requests_accepted:
                taken_days += request.number_of_days_temp

            av_days = hol.base_own_business - taken_days
            result[hol.id] = av_days

        return result

    def _get_available_holidays(self, cr, uid, ids, name, args, context=None):
        """

        """
        #Obtenemos todas las peticiones de ausencia validadas de un tipo determinado
        result = {}
        data_facade = self.pool.get('ir.model.data')
        holidays_facade = self.pool.get('hr.holidays')
        action_model,holiday_status_id = data_facade.get_object_reference(cr, uid, 'hr_holidays_extended', "hr_holidays_status_holiday")
        for hol in self.browse(cr, uid, ids, context=context):
            taken_days = 0.0
            first_day_of_year = '%s-01-01'%(hol.year)
            last_day_of_year = '%s-12-31' %(hol.year)
            requests_accepted = holidays_facade.browse(cr, uid, holidays_facade.search(cr, uid, [('employee_id','=', hol.employee_id.id),('type','=','remove'),('state','=', 'validate'), ('holiday_status_id','=', holiday_status_id), ('date_from','>=', first_day_of_year), ('date_from','<=',last_day_of_year), ('date_to','>=', first_day_of_year), ('date_to','<=',last_day_of_year)]))
            for request in requests_accepted:
                taken_days += request.number_of_days_temp

            av_days = hol.base_holidays - taken_days
            result[hol.id] = av_days

        return result

    def _get_pending_prev_year_holidays(self, cr, uid, ids, name, args, context=None):
        """

        """
        result = {}
        for hol in self.browse(cr, uid, ids, context=context):
            prev_year = hol.year -1
            hol_emp_lines = self.browse(cr, uid, self.search(cr, uid, [('employee_id','=', hol.employee_id.id), ('year','=', prev_year)]))
            hol_emp_line = hol_emp_lines and hol_emp_lines[0] or False
            if hol_emp_line:
                pending_days = hol_emp_line.available_holidays
            else:
                pending_days = 0.0

            result[hol.id] = pending_days

        return result


    _name= 'hr.holidays.employee'
    _columns = {
        'year': fields.integer('Year'),
        'employee_id': fields.many2one('hr.employee', 'Employee', required=True),
        'base_holidays': fields.integer('Initial holidays', help='Number of working days leave assigned to this employee'),
        'base_own_business': fields.integer('Initial own business days', help='Number of own business days assigned to this employee'),
        'taken_own_business': fields.function(_get_taken_own_business, method=True, type= 'float', digits_compute=dp.get_precision('Account'), string='Absences taken', help='Number of days this employee was absented'),
        'available_own_business': fields.function(_get_available_own_business, type= 'float', method=True, digits_compute=dp.get_precision('Account'), string='Absences available', help='Remaining absence days this employee can take'),
        'total_sickness': fields.function(_get_employee_sickness, method=True, type= 'float', string='Sickness', digits_compute=dp.get_precision('Account'), help='Number of days this employee was sick'),
        'taken_holidays': fields.function(_get_taken_holidays, method=True, string='Taken holidays', type= 'float', digits_compute=dp.get_precision('Account'), help='Number of days this employee took holidays'),
        'available_holidays': fields.function(_get_available_holidays, method=True, string='Remaining holidays', type= 'float', digits_compute=dp.get_precision('Account'), help='Remaining holidays for this employee'),
        'pending_prev_year_holidays': fields.function(_get_pending_prev_year_holidays, method=True, string='Prev. year pending holidays', type= 'float', digits_compute=dp.get_precision('Account'), help='Previous year pending holidays'),
     }
    _defaults = {
        'base_holidays': lambda *a: 23,
        'base_own_business': lambda *a: 3,
        'year': lambda self, cr, uid, context: datetime.datetime.now().year,
        'employee_id': lambda self, cr, uid, context: context and context.get('employee_id') and context['employee_id'] or False
     }

    _sql_constraints = [
        ('year_employee_uniq', 'unique (year,employee_id)', 'Only one row for year and employee!')
     ]


hr_holidays_employee()